{% extends 'sponsor_authed_base.html' %}

{% block main %}
    {% if new_key %}
        <div class="half-width" style="filter:blur(5px)" id="text1">
    {% else %}
        <div class="half-width" id="text1">
    {% endif %}
        <h2>Generate a new API Key</h2>
        <form action="{{ url_for('.apikeys_post') }}" target="_self" method="POST">
            <label for="name">Application Name</label>
            <input type="text" id="name" name="name" placeholder="Application Name"/><br />
            <input type="radio" id="dynamic" name="type" value="dynamic" checked/>
            <label for="dynamic">Dynamic (Cookie & Refresh Token - Recommended if using the library)</label><br />
            <input type="radio" id="bearer" value="bearer" name="type"/>
            <label for="bearer">Bearer Token</label><br />
            <input type="checkbox" id="tracking" checked name="tracking"/>
            <label for="tracking">Enable metrics tracking</label><br />
            <button>Generate</button>
        </form>
    </div>
    {% if new_key %}
        <div class="half-width" style="filter:blur(5px)" id="text2">
    {% else %}
        <div class="half-width" id="text2">
    {% endif %}
    <h2>Your keys</h2>
    <ul>
        {% for item in api_keys %}
            <li>
                <form action="{{ url_for('.apikeys_delete') }}" target="_self" method="POST" class="no-flex">
                    <span>{{ item["application_name"] }} {% if "key_id" in item %}({{ item["key_id"] }}){% endif %} - Key type: {{ item["key_type"] }} - Created: {{ item["created_at"] }} - Expires: {{ item["expires_at"] }}</span>
                    <input type="hidden" name="type" value="{{ item['key_type'] }}"/>
                    <input type="hidden" name="application_name" value="{{ item['application_name'] }}"/>
                    {% if "key_id" in item %}
                        <input type="hidden" name="key_id" value="{{ item['key_id'] }}"/>
                    {% endif %}
                    {% if tracked_keys[item["application_name"]] != None %}
                        -
                            <a href="{{ url_for('.apikeys_metrics', application_name=item['application_name']) }}">  {# nosemgrep #}
                                Metrics
                            </a>
                    {% endif %}
                    <button class="no-decoration"><img id="close-modal-pip" alt="Close Modal" src="/static/close-modal-pip.svg" /></button>
                </form>
            </li>
        {% endfor %}
    </ul>
    </div>
    <div class="full-column-right" id="text3">
    <h2>Metrics - {{ application_name }}</h2>
    <figure id="map" class="left-img">{{ map | safe }}<figcaption style="display: none">Map</figcaption></figure>   {# nosemgrep #}
    <figure id="chart" alt="Metrics Chart" class="left-img">
        {{visits_chart | safe}} {# nosemgrep #}
        <figcaption style="display: none">Chart</figcaption>
    </figure>
    <figure id="table" class="left-img">
        <figcaption style="display: none">Visitors Table</figcaption>
        <table>
                <th>Country</th><th>Avg. Visits</th><th>Max. Visits</th><th>Min. Visits</th><th>Unique Visitors</th>
            {% for row in table %}
                <tr>
                    <td>{{row["Country"]}}</td><td>{{row["Avg. Visits"]}}</td><td>{{row["Max. Visits"]}}</td><td>{{row["Min. Visits"]}}</td><td>{{row["Unique Visitors"]}}</td>
                </tr>
            {% endfor %}
        </table>
    </figure>
    </div>
    {% if new_key %}
        <div id="modal-overlay" onclick="closeModal();"></div>
        <div id="modal-dialog">
            <img id="close-modal-pip" alt="Close Modal" src="/static/close-modal-pip.svg" onclick="closeModal();" />
            <h2>New key</h2>
            {%  if "username" in new_key %}
                <div class="userpw">
                    <div id="username">
                        Username: {{ new_key["username"] }}
                    </div>
                    <div id="password">
                        Password: {{ new_key["password"] }}
                    </div>
                </div>
            {% else %}
                <div class="token">
                    Token: {{ new_key["token"] }}
                </div>
            {% endif %}
            {% if track and not tracked %}
                <b><span style="color:red;">NOTE: Tracking requested but was not available at this time</span></b>
            {% endif %}
        </div>
    {% endif %}
{% endblock %}